
import sys

from PyQt4 import QtCore
from PyQt4 import QtGui
from PyQt4.QtCore import QObject
from PyQt4.QtCore import QUrl
from PyQt4.QtCore import SIGNAL
from PyQt4.QtGui import QPainter
from PyQt4.QtGui import QPrinter
from PyQt4.QtGui import QImage
from PyQt4 import QtWebKit

class WebKitPDF ( QObject ):

    def __init__ ( self, url ):
        QObject.__init__ ( self )
        self.page = QtWebKit.QWebPage ( self )
        self.mainFrame = self.page.mainFrame()
        self.mainFrame.load ( QUrl ( url ) )

        self.connect ( self.page,
                       SIGNAL ( "loadProgress(int)" ),
                       self.loadProgress )

        self.connect ( self.page,
                       SIGNAL ( "loadFinished(bool)" ),
                       self.renderPDF )



    def loadProgress ( self, progress ):
        print "Progress: ", progress


    def renderPDF ( self, status ):
        print "Load finished with status: ", status
        print "Rendering PDF ..."

        contentsSize = self.mainFrame.contentsSize();
        self.page.setViewportSize ( contentsSize )

        self.printer = QPrinter ( QPrinter.PrinterResolution )
        self.printer.setOutputFormat ( QPrinter.PdfFormat )
        self.printer.setPaperSize ( QPrinter.A4 )
        self.printer.setOrientation ( QPrinter.Portrait )
        self.printer.setOutputFileName ( "wk.pdf" )

        self.painter = QPainter ( self.printer )
        self.painter.setRenderHint ( QPainter.Antialiasing )
        self.mainFrame.render ( self.painter )
        self.painter.end()
        app = QtGui.QApplication.instance()
        app.exit ( 0 )
        
        

def main():
    app = QtGui.QApplication ( sys.argv )
    wk = WebKitPDF ( "http://news.bbc.co.uk" )
    sys.exit ( app.exec_() )

if __name__ == "__main__":
    main()